<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    package com.jmatio.io;<a name="line.1"></a>
<FONT color="green">002</FONT>    <a name="line.2"></a>
<FONT color="green">003</FONT>    import java.io.ByteArrayOutputStream;<a name="line.3"></a>
<FONT color="green">004</FONT>    import java.io.DataOutputStream;<a name="line.4"></a>
<FONT color="green">005</FONT>    import java.io.File;<a name="line.5"></a>
<FONT color="green">006</FONT>    import java.io.FileNotFoundException;<a name="line.6"></a>
<FONT color="green">007</FONT>    import java.io.IOException;<a name="line.7"></a>
<FONT color="green">008</FONT>    import java.io.RandomAccessFile;<a name="line.8"></a>
<FONT color="green">009</FONT>    import java.nio.ByteBuffer;<a name="line.9"></a>
<FONT color="green">010</FONT>    import java.nio.ByteOrder;<a name="line.10"></a>
<FONT color="green">011</FONT>    import java.nio.channels.FileChannel;<a name="line.11"></a>
<FONT color="green">012</FONT>    import java.util.ArrayList;<a name="line.12"></a>
<FONT color="green">013</FONT>    import java.util.LinkedHashMap;<a name="line.13"></a>
<FONT color="green">014</FONT>    import java.util.Map;<a name="line.14"></a>
<FONT color="green">015</FONT>    import java.util.zip.DataFormatException;<a name="line.15"></a>
<FONT color="green">016</FONT>    import java.util.zip.Inflater;<a name="line.16"></a>
<FONT color="green">017</FONT>    <a name="line.17"></a>
<FONT color="green">018</FONT>    import com.jmatio.common.MatDataTypes;<a name="line.18"></a>
<FONT color="green">019</FONT>    import com.jmatio.types.MLArray;<a name="line.19"></a>
<FONT color="green">020</FONT>    import com.jmatio.types.MLCell;<a name="line.20"></a>
<FONT color="green">021</FONT>    import com.jmatio.types.MLChar;<a name="line.21"></a>
<FONT color="green">022</FONT>    import com.jmatio.types.MLDouble;<a name="line.22"></a>
<FONT color="green">023</FONT>    import com.jmatio.types.MLSparse;<a name="line.23"></a>
<FONT color="green">024</FONT>    import com.jmatio.types.MLStructure;<a name="line.24"></a>
<FONT color="green">025</FONT>    <a name="line.25"></a>
<FONT color="green">026</FONT>    /**<a name="line.26"></a>
<FONT color="green">027</FONT>     * MAT-file reader. Reads MAT-file into &lt;code&gt;MLArray&lt;/code&gt; objects.<a name="line.27"></a>
<FONT color="green">028</FONT>     * <a name="line.28"></a>
<FONT color="green">029</FONT>     * Usage:<a name="line.29"></a>
<FONT color="green">030</FONT>     * &lt;pre&gt;&lt;code&gt;<a name="line.30"></a>
<FONT color="green">031</FONT>     * //read in the file<a name="line.31"></a>
<FONT color="green">032</FONT>     * MatFileReader mfr = new MatFileReader( "mat_file.mat" );<a name="line.32"></a>
<FONT color="green">033</FONT>     * <a name="line.33"></a>
<FONT color="green">034</FONT>     * //get array of a name "my_array" from file<a name="line.34"></a>
<FONT color="green">035</FONT>     * MLArray mlArrayRetrived = mfr.getMLArray( "my_array" );<a name="line.35"></a>
<FONT color="green">036</FONT>     * <a name="line.36"></a>
<FONT color="green">037</FONT>     * //or get the collection of all arrays that were stored in the file<a name="line.37"></a>
<FONT color="green">038</FONT>     * Map content = mfr.getContent();<a name="line.38"></a>
<FONT color="green">039</FONT>     * &lt;/pre&gt;&lt;/code&gt;<a name="line.39"></a>
<FONT color="green">040</FONT>     * <a name="line.40"></a>
<FONT color="green">041</FONT>     * @see com.jmatio.io.MatFileFilter<a name="line.41"></a>
<FONT color="green">042</FONT>     * @author Wojciech Gradkowski (&lt;a href="mailto:wgradkowski@gmail.com"&gt;wgradkowski@gmail.com&lt;/a&gt;)<a name="line.42"></a>
<FONT color="green">043</FONT>     */<a name="line.43"></a>
<FONT color="green">044</FONT>    /**<a name="line.44"></a>
<FONT color="green">045</FONT>     * @author Wojciech Gradkowski (&lt;a href="mailto:wgradkowski@gmail.com"&gt;wgradkowski@gmail.com&lt;/a&gt;)<a name="line.45"></a>
<FONT color="green">046</FONT>     *<a name="line.46"></a>
<FONT color="green">047</FONT>     */<a name="line.47"></a>
<FONT color="green">048</FONT>    public class MatFileReader<a name="line.48"></a>
<FONT color="green">049</FONT>    {<a name="line.49"></a>
<FONT color="green">050</FONT>        /**<a name="line.50"></a>
<FONT color="green">051</FONT>         * MAT-file header<a name="line.51"></a>
<FONT color="green">052</FONT>         */<a name="line.52"></a>
<FONT color="green">053</FONT>        private MatFileHeader matFileHeader;<a name="line.53"></a>
<FONT color="green">054</FONT>        /**<a name="line.54"></a>
<FONT color="green">055</FONT>         * Container for red &lt;code&gt;MLArray&lt;/code&gt;s<a name="line.55"></a>
<FONT color="green">056</FONT>         */<a name="line.56"></a>
<FONT color="green">057</FONT>        private Map&lt;String, MLArray&gt; data;<a name="line.57"></a>
<FONT color="green">058</FONT>        /**<a name="line.58"></a>
<FONT color="green">059</FONT>         * Tells how bytes are organized in the buffer.<a name="line.59"></a>
<FONT color="green">060</FONT>         */<a name="line.60"></a>
<FONT color="green">061</FONT>        private ByteOrder byteOrder;<a name="line.61"></a>
<FONT color="green">062</FONT>        /**<a name="line.62"></a>
<FONT color="green">063</FONT>         * Array name filter<a name="line.63"></a>
<FONT color="green">064</FONT>         */<a name="line.64"></a>
<FONT color="green">065</FONT>        private MatFileFilter filter;<a name="line.65"></a>
<FONT color="green">066</FONT>        /**<a name="line.66"></a>
<FONT color="green">067</FONT>         * Creates instance of &lt;code&gt;MatFileReader&lt;/code&gt; and reads MAT-file <a name="line.67"></a>
<FONT color="green">068</FONT>         * from location given as &lt;code&gt;fileName&lt;/code&gt;.<a name="line.68"></a>
<FONT color="green">069</FONT>         * <a name="line.69"></a>
<FONT color="green">070</FONT>         * This method reads MAT-file withiout filtering.<a name="line.70"></a>
<FONT color="green">071</FONT>         * <a name="line.71"></a>
<FONT color="green">072</FONT>         * @param fileName the MAT-file path &lt;code&gt;String&lt;/code&gt;<a name="line.72"></a>
<FONT color="green">073</FONT>         * @throws IOException when error occured while processing the file.<a name="line.73"></a>
<FONT color="green">074</FONT>         */<a name="line.74"></a>
<FONT color="green">075</FONT>        public MatFileReader(String fileName) throws FileNotFoundException, IOException<a name="line.75"></a>
<FONT color="green">076</FONT>        {<a name="line.76"></a>
<FONT color="green">077</FONT>            this ( new File(fileName), new MatFileFilter() );<a name="line.77"></a>
<FONT color="green">078</FONT>        }<a name="line.78"></a>
<FONT color="green">079</FONT>        /**<a name="line.79"></a>
<FONT color="green">080</FONT>         * Creates instance of &lt;code&gt;MatFileReader&lt;/code&gt; and reads MAT-file <a name="line.80"></a>
<FONT color="green">081</FONT>         * from location given as &lt;code&gt;fileName&lt;/code&gt;.<a name="line.81"></a>
<FONT color="green">082</FONT>         * <a name="line.82"></a>
<FONT color="green">083</FONT>         * Results are filtered by &lt;code&gt;MatFileFilter&lt;/code&gt;. Arrays that do not meet<a name="line.83"></a>
<FONT color="green">084</FONT>         * filter match condition will not be avalable in results.<a name="line.84"></a>
<FONT color="green">085</FONT>         * <a name="line.85"></a>
<FONT color="green">086</FONT>         * @param fileName  the MAT-file path &lt;code&gt;String&lt;/code&gt;<a name="line.86"></a>
<FONT color="green">087</FONT>         * @param filter    array name filter.<a name="line.87"></a>
<FONT color="green">088</FONT>         * @throws IOException when error occured while processing the file.<a name="line.88"></a>
<FONT color="green">089</FONT>         */<a name="line.89"></a>
<FONT color="green">090</FONT>        public MatFileReader(String fileName, MatFileFilter filter ) throws IOException<a name="line.90"></a>
<FONT color="green">091</FONT>        {<a name="line.91"></a>
<FONT color="green">092</FONT>            this( new File(fileName), filter );<a name="line.92"></a>
<FONT color="green">093</FONT>        }<a name="line.93"></a>
<FONT color="green">094</FONT>        /**<a name="line.94"></a>
<FONT color="green">095</FONT>         * Creates instance of &lt;code&gt;MatFileReader&lt;/code&gt; and reads MAT-file <a name="line.95"></a>
<FONT color="green">096</FONT>         * from &lt;code&gt;file&lt;/code&gt;. <a name="line.96"></a>
<FONT color="green">097</FONT>         * <a name="line.97"></a>
<FONT color="green">098</FONT>         * This method reads MAT-file withiout filtering.<a name="line.98"></a>
<FONT color="green">099</FONT>         * <a name="line.99"></a>
<FONT color="green">100</FONT>         * @param file the MAT-file<a name="line.100"></a>
<FONT color="green">101</FONT>         * @throws IOException when error occured while processing the file.<a name="line.101"></a>
<FONT color="green">102</FONT>         */<a name="line.102"></a>
<FONT color="green">103</FONT>        public MatFileReader(File file) throws IOException<a name="line.103"></a>
<FONT color="green">104</FONT>        {<a name="line.104"></a>
<FONT color="green">105</FONT>            this ( file, new MatFileFilter() );<a name="line.105"></a>
<FONT color="green">106</FONT>            <a name="line.106"></a>
<FONT color="green">107</FONT>        }<a name="line.107"></a>
<FONT color="green">108</FONT>        /**<a name="line.108"></a>
<FONT color="green">109</FONT>         * Creates instance of &lt;code&gt;MatFileReader&lt;/code&gt; and reads MAT-file <a name="line.109"></a>
<FONT color="green">110</FONT>         * from &lt;code&gt;file&lt;/code&gt;.<a name="line.110"></a>
<FONT color="green">111</FONT>         * <a name="line.111"></a>
<FONT color="green">112</FONT>         * Results are filtered by &lt;code&gt;MatFileFilter&lt;/code&gt;. Arrays that do not meet<a name="line.112"></a>
<FONT color="green">113</FONT>         * filter match condition will not be avalable in results.<a name="line.113"></a>
<FONT color="green">114</FONT>         * <a name="line.114"></a>
<FONT color="green">115</FONT>         * @param file              the MAT-file<a name="line.115"></a>
<FONT color="green">116</FONT>         * @param filter    array name filter.<a name="line.116"></a>
<FONT color="green">117</FONT>         * @throws IOException when error occured while processing the file.<a name="line.117"></a>
<FONT color="green">118</FONT>         */<a name="line.118"></a>
<FONT color="green">119</FONT>        public MatFileReader(File file, MatFileFilter filter) throws IOException<a name="line.119"></a>
<FONT color="green">120</FONT>        {<a name="line.120"></a>
<FONT color="green">121</FONT>            this.filter = filter;<a name="line.121"></a>
<FONT color="green">122</FONT>            data = new LinkedHashMap&lt;String, MLArray&gt;();<a name="line.122"></a>
<FONT color="green">123</FONT>            <a name="line.123"></a>
<FONT color="green">124</FONT>            //Create a read-only memory-mapped file<a name="line.124"></a>
<FONT color="green">125</FONT>            FileChannel roChannel = new RandomAccessFile(file, "r").getChannel();<a name="line.125"></a>
<FONT color="green">126</FONT>            ByteBuffer buf = roChannel.map(FileChannel.MapMode.READ_ONLY, 0, (int)roChannel.size());        <a name="line.126"></a>
<FONT color="green">127</FONT>            <a name="line.127"></a>
<FONT color="green">128</FONT>            //read in file header<a name="line.128"></a>
<FONT color="green">129</FONT>            readHeader(buf);<a name="line.129"></a>
<FONT color="green">130</FONT>            <a name="line.130"></a>
<FONT color="green">131</FONT>            while ( buf.remaining() &gt; 0 )<a name="line.131"></a>
<FONT color="green">132</FONT>            {<a name="line.132"></a>
<FONT color="green">133</FONT>                readData( buf );<a name="line.133"></a>
<FONT color="green">134</FONT>            }<a name="line.134"></a>
<FONT color="green">135</FONT>            <a name="line.135"></a>
<FONT color="green">136</FONT>            //close file channel<a name="line.136"></a>
<FONT color="green">137</FONT>            roChannel.close();<a name="line.137"></a>
<FONT color="green">138</FONT>            <a name="line.138"></a>
<FONT color="green">139</FONT>        }<a name="line.139"></a>
<FONT color="green">140</FONT>        /**<a name="line.140"></a>
<FONT color="green">141</FONT>         * Gets MAT-file header<a name="line.141"></a>
<FONT color="green">142</FONT>         * <a name="line.142"></a>
<FONT color="green">143</FONT>         * @return - a &lt;code&gt;MatFileHeader&lt;/code&gt; object<a name="line.143"></a>
<FONT color="green">144</FONT>         */<a name="line.144"></a>
<FONT color="green">145</FONT>        public MatFileHeader getMatFileHeader()<a name="line.145"></a>
<FONT color="green">146</FONT>        {<a name="line.146"></a>
<FONT color="green">147</FONT>            return matFileHeader;<a name="line.147"></a>
<FONT color="green">148</FONT>        }<a name="line.148"></a>
<FONT color="green">149</FONT>        /**<a name="line.149"></a>
<FONT color="green">150</FONT>         * Returns list of &lt;code&gt;MLArray&lt;/code&gt; objects that were inside MAT-file<a name="line.150"></a>
<FONT color="green">151</FONT>         * <a name="line.151"></a>
<FONT color="green">152</FONT>         * @return - a &lt;code&gt;ArrayList&lt;/code&gt;<a name="line.152"></a>
<FONT color="green">153</FONT>         * @deprecated use &lt;code&gt;getContent&lt;/code&gt; which returs a Map to provide <a name="line.153"></a>
<FONT color="green">154</FONT>         *             easier access to &lt;code&gt;MLArray&lt;/code&gt;s contained in MAT-file<a name="line.154"></a>
<FONT color="green">155</FONT>         */<a name="line.155"></a>
<FONT color="green">156</FONT>        @Deprecated<a name="line.156"></a>
<FONT color="green">157</FONT>            public ArrayList&lt;MLArray&gt; getData()<a name="line.157"></a>
<FONT color="green">158</FONT>        {<a name="line.158"></a>
<FONT color="green">159</FONT>            return new ArrayList&lt;MLArray&gt;( data.values() );<a name="line.159"></a>
<FONT color="green">160</FONT>        }<a name="line.160"></a>
<FONT color="green">161</FONT>        /**<a name="line.161"></a>
<FONT color="green">162</FONT>         * Returns the value to which the red file maps the specified array name.<a name="line.162"></a>
<FONT color="green">163</FONT>         * <a name="line.163"></a>
<FONT color="green">164</FONT>         * Returns &lt;code&gt;null&lt;/code&gt; if the file contains no content for this name.<a name="line.164"></a>
<FONT color="green">165</FONT>         * <a name="line.165"></a>
<FONT color="green">166</FONT>         * @param name array name<a name="line.166"></a>
<FONT color="green">167</FONT>         * @return the &lt;code&gt;MLArray&lt;/code&gt; to which this file maps the specified name, <a name="line.167"></a>
<FONT color="green">168</FONT>         *           or null if the file contains no content for this name.<a name="line.168"></a>
<FONT color="green">169</FONT>         */<a name="line.169"></a>
<FONT color="green">170</FONT>        public MLArray getMLArray( String name )<a name="line.170"></a>
<FONT color="green">171</FONT>        {<a name="line.171"></a>
<FONT color="green">172</FONT>            return data.get( name );<a name="line.172"></a>
<FONT color="green">173</FONT>        }<a name="line.173"></a>
<FONT color="green">174</FONT>        /**<a name="line.174"></a>
<FONT color="green">175</FONT>         * Returns a map of &lt;code&gt;MLArray&lt;/code&gt; objects that were inside MAT-file.<a name="line.175"></a>
<FONT color="green">176</FONT>         * <a name="line.176"></a>
<FONT color="green">177</FONT>         * MLArrays are mapped with MLArrays' names<a name="line.177"></a>
<FONT color="green">178</FONT>         *  <a name="line.178"></a>
<FONT color="green">179</FONT>         * @return - a &lt;code&gt;Map&lt;/code&gt; of MLArrays mapped with theid names.<a name="line.179"></a>
<FONT color="green">180</FONT>         */<a name="line.180"></a>
<FONT color="green">181</FONT>        public Map&lt;String, MLArray&gt; getContent()<a name="line.181"></a>
<FONT color="green">182</FONT>        {<a name="line.182"></a>
<FONT color="green">183</FONT>            return data;<a name="line.183"></a>
<FONT color="green">184</FONT>        }<a name="line.184"></a>
<FONT color="green">185</FONT>        /**<a name="line.185"></a>
<FONT color="green">186</FONT>         * Decompresses (inflates) bytes from input stream.<a name="line.186"></a>
<FONT color="green">187</FONT>         * <a name="line.187"></a>
<FONT color="green">188</FONT>         * Stream marker is being set at +&lt;code&gt;numOfBytes&lt;/code&gt; positon of the<a name="line.188"></a>
<FONT color="green">189</FONT>         * stream.<a name="line.189"></a>
<FONT color="green">190</FONT>         * <a name="line.190"></a>
<FONT color="green">191</FONT>         * @param buf -<a name="line.191"></a>
<FONT color="green">192</FONT>         *            input byte buffer<a name="line.192"></a>
<FONT color="green">193</FONT>         * @param numOfBytes -<a name="line.193"></a>
<FONT color="green">194</FONT>         *            number of bytes to be red<a name="line.194"></a>
<FONT color="green">195</FONT>         * @return - new &lt;code&gt;ByteBuffer&lt;/code&gt; with infladed block of data<a name="line.195"></a>
<FONT color="green">196</FONT>         * @throws IOException<a name="line.196"></a>
<FONT color="green">197</FONT>         *             when error occurs while reading or inflating the buffer .<a name="line.197"></a>
<FONT color="green">198</FONT>         */<a name="line.198"></a>
<FONT color="green">199</FONT>        private ByteBuffer inflate(ByteBuffer buf, int numOfBytes) throws IOException<a name="line.199"></a>
<FONT color="green">200</FONT>        {<a name="line.200"></a>
<FONT color="green">201</FONT>            byte[] compressed = new byte[numOfBytes];<a name="line.201"></a>
<FONT color="green">202</FONT>            buf.get(compressed);<a name="line.202"></a>
<FONT color="green">203</FONT>            <a name="line.203"></a>
<FONT color="green">204</FONT>            //get new inflater instance<a name="line.204"></a>
<FONT color="green">205</FONT>            Inflater decompresser = new Inflater();<a name="line.205"></a>
<FONT color="green">206</FONT>            decompresser.setInput(compressed);<a name="line.206"></a>
<FONT color="green">207</FONT>            <a name="line.207"></a>
<FONT color="green">208</FONT>            byte[] result = new byte[128];<a name="line.208"></a>
<FONT color="green">209</FONT>            ByteArrayOutputStream baos = new ByteArrayOutputStream();<a name="line.209"></a>
<FONT color="green">210</FONT>            DataOutputStream dos = new DataOutputStream( baos );<a name="line.210"></a>
<FONT color="green">211</FONT>            int i;<a name="line.211"></a>
<FONT color="green">212</FONT>            try<a name="line.212"></a>
<FONT color="green">213</FONT>            {<a name="line.213"></a>
<FONT color="green">214</FONT>                do<a name="line.214"></a>
<FONT color="green">215</FONT>                {<a name="line.215"></a>
<FONT color="green">216</FONT>                    i = decompresser.inflate(result);<a name="line.216"></a>
<FONT color="green">217</FONT>                    dos.write(result);<a name="line.217"></a>
<FONT color="green">218</FONT>                }<a name="line.218"></a>
<FONT color="green">219</FONT>                while ( i &gt; 0 );<a name="line.219"></a>
<FONT color="green">220</FONT>                <a name="line.220"></a>
<FONT color="green">221</FONT>            }<a name="line.221"></a>
<FONT color="green">222</FONT>            catch ( DataFormatException e )<a name="line.222"></a>
<FONT color="green">223</FONT>            {<a name="line.223"></a>
<FONT color="green">224</FONT>                throw new MatlabIOException("Cound not decompress data: " + e );<a name="line.224"></a>
<FONT color="green">225</FONT>            }<a name="line.225"></a>
<FONT color="green">226</FONT>            finally<a name="line.226"></a>
<FONT color="green">227</FONT>            {<a name="line.227"></a>
<FONT color="green">228</FONT>                decompresser.end();<a name="line.228"></a>
<FONT color="green">229</FONT>            }<a name="line.229"></a>
<FONT color="green">230</FONT>            ByteBuffer out = ByteBuffer.wrap( baos.toByteArray() );<a name="line.230"></a>
<FONT color="green">231</FONT>            out.order( byteOrder );<a name="line.231"></a>
<FONT color="green">232</FONT>            return out;<a name="line.232"></a>
<FONT color="green">233</FONT>            <a name="line.233"></a>
<FONT color="green">234</FONT>        }<a name="line.234"></a>
<FONT color="green">235</FONT>        /**<a name="line.235"></a>
<FONT color="green">236</FONT>         * Reads data form byte buffer. Searches for either<a name="line.236"></a>
<FONT color="green">237</FONT>         * &lt;code&gt;miCOMPRESSED&lt;/code&gt; data or &lt;code&gt;miMATRIX&lt;/code&gt; data.<a name="line.237"></a>
<FONT color="green">238</FONT>         * <a name="line.238"></a>
<FONT color="green">239</FONT>         * Compressed data are inflated and the product is recursively passed back<a name="line.239"></a>
<FONT color="green">240</FONT>         * to this same method.<a name="line.240"></a>
<FONT color="green">241</FONT>         * <a name="line.241"></a>
<FONT color="green">242</FONT>         * Modifies &lt;code&gt;buf&lt;/code&gt; position.<a name="line.242"></a>
<FONT color="green">243</FONT>         * <a name="line.243"></a>
<FONT color="green">244</FONT>         * @param buf -<a name="line.244"></a>
<FONT color="green">245</FONT>         *            input byte buffer<a name="line.245"></a>
<FONT color="green">246</FONT>         * @throws IOException when error occurs while reading the buffer.<a name="line.246"></a>
<FONT color="green">247</FONT>         */<a name="line.247"></a>
<FONT color="green">248</FONT>        private void readData( ByteBuffer buf ) throws IOException<a name="line.248"></a>
<FONT color="green">249</FONT>        {<a name="line.249"></a>
<FONT color="green">250</FONT>            //read data<a name="line.250"></a>
<FONT color="green">251</FONT>            ISMatTag tag = new ISMatTag(buf);<a name="line.251"></a>
<FONT color="green">252</FONT>            switch ( tag.type )<a name="line.252"></a>
<FONT color="green">253</FONT>            {<a name="line.253"></a>
<FONT color="green">254</FONT>                case MatDataTypes.miCOMPRESSED:<a name="line.254"></a>
<FONT color="green">255</FONT>                    //inflate and recur<a name="line.255"></a>
<FONT color="green">256</FONT>                    readData( inflate(buf, tag.size)  );<a name="line.256"></a>
<FONT color="green">257</FONT>                    break;<a name="line.257"></a>
<FONT color="green">258</FONT>                case MatDataTypes.miMATRIX:<a name="line.258"></a>
<FONT color="green">259</FONT>                    <a name="line.259"></a>
<FONT color="green">260</FONT>                    //read in the matrix<a name="line.260"></a>
<FONT color="green">261</FONT>                    int pos = buf.position();<a name="line.261"></a>
<FONT color="green">262</FONT>                    <a name="line.262"></a>
<FONT color="green">263</FONT>                    MLArray element = readMatrix( buf, true );<a name="line.263"></a>
<FONT color="green">264</FONT>                    <a name="line.264"></a>
<FONT color="green">265</FONT>                    if ( element != null )<a name="line.265"></a>
<FONT color="green">266</FONT>                    {<a name="line.266"></a>
<FONT color="green">267</FONT>                        data.put( element.getName(), element );<a name="line.267"></a>
<FONT color="green">268</FONT>                    }<a name="line.268"></a>
<FONT color="green">269</FONT>                    else<a name="line.269"></a>
<FONT color="green">270</FONT>                    {<a name="line.270"></a>
<FONT color="green">271</FONT>                        int red = buf.position() - pos;<a name="line.271"></a>
<FONT color="green">272</FONT>                        int toread = tag.size - red;<a name="line.272"></a>
<FONT color="green">273</FONT>                        buf.position( buf.position() + toread );<a name="line.273"></a>
<FONT color="green">274</FONT>                    }<a name="line.274"></a>
<FONT color="green">275</FONT>                    int red = buf.position() - pos;<a name="line.275"></a>
<FONT color="green">276</FONT>    <a name="line.276"></a>
<FONT color="green">277</FONT>                    int toread = tag.size - red;<a name="line.277"></a>
<FONT color="green">278</FONT>                    <a name="line.278"></a>
<FONT color="green">279</FONT>                    if ( toread != 0 )<a name="line.279"></a>
<FONT color="green">280</FONT>                    {<a name="line.280"></a>
<FONT color="green">281</FONT>                        throw new MatlabIOException("Matrix was not red fully! " + toread + " remainging in the buffer.");<a name="line.281"></a>
<FONT color="green">282</FONT>                    }<a name="line.282"></a>
<FONT color="green">283</FONT>                    break;<a name="line.283"></a>
<FONT color="green">284</FONT>                default:<a name="line.284"></a>
<FONT color="green">285</FONT>                    throw new MatlabIOException("Incorrect data tag: " + tag);<a name="line.285"></a>
<FONT color="green">286</FONT>                        <a name="line.286"></a>
<FONT color="green">287</FONT>            }<a name="line.287"></a>
<FONT color="green">288</FONT>        }<a name="line.288"></a>
<FONT color="green">289</FONT>        /**<a name="line.289"></a>
<FONT color="green">290</FONT>         * Reads miMATRIX from from input stream.<a name="line.290"></a>
<FONT color="green">291</FONT>         * <a name="line.291"></a>
<FONT color="green">292</FONT>         * If reading was not finished (which is normal for filtered results)<a name="line.292"></a>
<FONT color="green">293</FONT>         * returns &lt;cod&gt;null&lt;/code&gt;.<a name="line.293"></a>
<FONT color="green">294</FONT>         * <a name="line.294"></a>
<FONT color="green">295</FONT>         * Modifies &lt;code&gt;buf&lt;/code&gt; position to the position when reading<a name="line.295"></a>
<FONT color="green">296</FONT>         * finished.<a name="line.296"></a>
<FONT color="green">297</FONT>         * <a name="line.297"></a>
<FONT color="green">298</FONT>         * Uses recursive processing for some ML**** data types.<a name="line.298"></a>
<FONT color="green">299</FONT>         * <a name="line.299"></a>
<FONT color="green">300</FONT>         * @param buf -<a name="line.300"></a>
<FONT color="green">301</FONT>         *            input byte buffer<a name="line.301"></a>
<FONT color="green">302</FONT>         * @param isRoot -<a name="line.302"></a>
<FONT color="green">303</FONT>         *            when &lt;code&gt;true&lt;/code&gt; informs that if this is a top level<a name="line.303"></a>
<FONT color="green">304</FONT>         *            matrix<a name="line.304"></a>
<FONT color="green">305</FONT>         * @return - &lt;code&gt;MLArray&lt;/code&gt; or &lt;code&gt;null&lt;/code&gt; if matrix does<a name="line.305"></a>
<FONT color="green">306</FONT>         *         not match &lt;code&gt;filter&lt;/code&gt;<a name="line.306"></a>
<FONT color="green">307</FONT>         * @throws IOException when error occurs while reading the buffer.<a name="line.307"></a>
<FONT color="green">308</FONT>         */<a name="line.308"></a>
<FONT color="green">309</FONT>        private MLArray readMatrix(ByteBuffer buf, boolean isRoot ) throws IOException<a name="line.309"></a>
<FONT color="green">310</FONT>        {<a name="line.310"></a>
<FONT color="green">311</FONT>            //result<a name="line.311"></a>
<FONT color="green">312</FONT>            MLArray mlArray;<a name="line.312"></a>
<FONT color="green">313</FONT>            ISMatTag tag;<a name="line.313"></a>
<FONT color="green">314</FONT>            <a name="line.314"></a>
<FONT color="green">315</FONT>            //read flags<a name="line.315"></a>
<FONT color="green">316</FONT>            int[] flags = readFlags(buf);<a name="line.316"></a>
<FONT color="green">317</FONT>            int attributes = flags[0];<a name="line.317"></a>
<FONT color="green">318</FONT>            int nzmax = flags[1];<a name="line.318"></a>
<FONT color="green">319</FONT>            int type = attributes &amp; 0xff;<a name="line.319"></a>
<FONT color="green">320</FONT>            <a name="line.320"></a>
<FONT color="green">321</FONT>            //read Array dimension<a name="line.321"></a>
<FONT color="green">322</FONT>            int[] dims = readDimension(buf);<a name="line.322"></a>
<FONT color="green">323</FONT>            <a name="line.323"></a>
<FONT color="green">324</FONT>            //read array Name<a name="line.324"></a>
<FONT color="green">325</FONT>            String name = readName(buf);<a name="line.325"></a>
<FONT color="green">326</FONT>            <a name="line.326"></a>
<FONT color="green">327</FONT>            //if this array is filtered out retur imediately<a name="line.327"></a>
<FONT color="green">328</FONT>            if ( isRoot &amp;&amp; !filter.matches(name) )<a name="line.328"></a>
<FONT color="green">329</FONT>            {<a name="line.329"></a>
<FONT color="green">330</FONT>                return null;<a name="line.330"></a>
<FONT color="green">331</FONT>            }<a name="line.331"></a>
<FONT color="green">332</FONT>            <a name="line.332"></a>
<FONT color="green">333</FONT>    <a name="line.333"></a>
<FONT color="green">334</FONT>            //read data &gt;&gt; consider changing it to stategy pattern<a name="line.334"></a>
<FONT color="green">335</FONT>            switch ( type )<a name="line.335"></a>
<FONT color="green">336</FONT>            {<a name="line.336"></a>
<FONT color="green">337</FONT>                case MLArray.mxSTRUCT_CLASS:<a name="line.337"></a>
<FONT color="green">338</FONT>                    <a name="line.338"></a>
<FONT color="green">339</FONT>                    MLStructure struct = new MLStructure(name, dims, type, attributes);<a name="line.339"></a>
<FONT color="green">340</FONT>                    <a name="line.340"></a>
<FONT color="green">341</FONT>                    //field name lenght - this subelement always uses the compressed data element format<a name="line.341"></a>
<FONT color="green">342</FONT>                    tag = new ISMatTag(buf);<a name="line.342"></a>
<FONT color="green">343</FONT>                    int maxlen = buf.getInt(); //maximum field length<a name="line.343"></a>
<FONT color="green">344</FONT>    <a name="line.344"></a>
<FONT color="green">345</FONT>                    //////  read fields data as Int8<a name="line.345"></a>
<FONT color="green">346</FONT>                    tag = new ISMatTag(buf);<a name="line.346"></a>
<FONT color="green">347</FONT>                    //calculate number of fields<a name="line.347"></a>
<FONT color="green">348</FONT>                    int numOfFields = tag.size/maxlen;<a name="line.348"></a>
<FONT color="green">349</FONT>                    <a name="line.349"></a>
<FONT color="green">350</FONT>                    //padding after field names<a name="line.350"></a>
<FONT color="green">351</FONT>                    int padding = (tag.size%8) != 0 ? 8-(tag.size%8) : 0;<a name="line.351"></a>
<FONT color="green">352</FONT>    <a name="line.352"></a>
<FONT color="green">353</FONT>                    String[] fieldNames = new String[numOfFields];<a name="line.353"></a>
<FONT color="green">354</FONT>                    for ( int i = 0; i &lt; numOfFields; i++ )<a name="line.354"></a>
<FONT color="green">355</FONT>                    {<a name="line.355"></a>
<FONT color="green">356</FONT>                        byte[] names = new byte[maxlen];<a name="line.356"></a>
<FONT color="green">357</FONT>                        buf.get(names);<a name="line.357"></a>
<FONT color="green">358</FONT>                        fieldNames[i] = zeroEndByteArrayToString(names);<a name="line.358"></a>
<FONT color="green">359</FONT>                    }<a name="line.359"></a>
<FONT color="green">360</FONT>                    buf.position( buf.position() + padding );<a name="line.360"></a>
<FONT color="green">361</FONT>                    <a name="line.361"></a>
<FONT color="green">362</FONT>                    //read fields<a name="line.362"></a>
<FONT color="green">363</FONT>                    for ( int index = 0; index &lt; struct.getM()*struct.getN(); index++ )<a name="line.363"></a>
<FONT color="green">364</FONT>                    {<a name="line.364"></a>
<FONT color="green">365</FONT>                        for ( int i = 0; i &lt; numOfFields; i++ )<a name="line.365"></a>
<FONT color="green">366</FONT>                        {<a name="line.366"></a>
<FONT color="green">367</FONT>                            //read matrix recursively<a name="line.367"></a>
<FONT color="green">368</FONT>                            tag = new ISMatTag(buf);<a name="line.368"></a>
<FONT color="green">369</FONT>                            MLArray fieldValue = readMatrix( buf, false);<a name="line.369"></a>
<FONT color="green">370</FONT>                            struct.setField(fieldNames[i], fieldValue, index);<a name="line.370"></a>
<FONT color="green">371</FONT>                        }<a name="line.371"></a>
<FONT color="green">372</FONT>                    }<a name="line.372"></a>
<FONT color="green">373</FONT>                    mlArray = struct;<a name="line.373"></a>
<FONT color="green">374</FONT>                    break;<a name="line.374"></a>
<FONT color="green">375</FONT>                case MLArray.mxCELL_CLASS:<a name="line.375"></a>
<FONT color="green">376</FONT>                    MLCell cell = new MLCell(name, dims, type, attributes);<a name="line.376"></a>
<FONT color="green">377</FONT>                    for ( int i = 0; i &lt; cell.getM()*cell.getN(); i++ )<a name="line.377"></a>
<FONT color="green">378</FONT>                    {<a name="line.378"></a>
<FONT color="green">379</FONT>                        tag = new ISMatTag(buf);<a name="line.379"></a>
<FONT color="green">380</FONT>                        //read matrix recursively<a name="line.380"></a>
<FONT color="green">381</FONT>                        MLArray cellmatrix = readMatrix( buf, false);<a name="line.381"></a>
<FONT color="green">382</FONT>                        cell.set(cellmatrix, i);<a name="line.382"></a>
<FONT color="green">383</FONT>                    }<a name="line.383"></a>
<FONT color="green">384</FONT>                    mlArray = cell;<a name="line.384"></a>
<FONT color="green">385</FONT>                    break;<a name="line.385"></a>
<FONT color="green">386</FONT>                case MLArray.mxDOUBLE_CLASS:<a name="line.386"></a>
<FONT color="green">387</FONT>                    <a name="line.387"></a>
<FONT color="green">388</FONT>                    double[] ad;<a name="line.388"></a>
<FONT color="green">389</FONT>                    MLDouble mldouble = new MLDouble(name, dims, type, attributes);<a name="line.389"></a>
<FONT color="green">390</FONT>                    <a name="line.390"></a>
<FONT color="green">391</FONT>                    //read real<a name="line.391"></a>
<FONT color="green">392</FONT>                    tag = new ISMatTag(buf);<a name="line.392"></a>
<FONT color="green">393</FONT>                    ad = tag.readToDoubleArray();<a name="line.393"></a>
<FONT color="green">394</FONT>                    for ( int i = 0; i &lt; ad.length; i++ )<a name="line.394"></a>
<FONT color="green">395</FONT>                    {<a name="line.395"></a>
<FONT color="green">396</FONT>                        mldouble.setReal( Double.valueOf(ad[i]), i );<a name="line.396"></a>
<FONT color="green">397</FONT>                    }<a name="line.397"></a>
<FONT color="green">398</FONT>                    //read complex<a name="line.398"></a>
<FONT color="green">399</FONT>                    if ( mldouble.isComplex() )<a name="line.399"></a>
<FONT color="green">400</FONT>                    {<a name="line.400"></a>
<FONT color="green">401</FONT>                        tag = new ISMatTag(buf);<a name="line.401"></a>
<FONT color="green">402</FONT>                        ad = tag.readToDoubleArray();<a name="line.402"></a>
<FONT color="green">403</FONT>                        for ( int i = 0; i &lt; ad.length; i++ )<a name="line.403"></a>
<FONT color="green">404</FONT>                        {<a name="line.404"></a>
<FONT color="green">405</FONT>                            mldouble.setReal( Double.valueOf(ad[i]), i );<a name="line.405"></a>
<FONT color="green">406</FONT>                        }<a name="line.406"></a>
<FONT color="green">407</FONT>                    }<a name="line.407"></a>
<FONT color="green">408</FONT>                    mlArray = mldouble;<a name="line.408"></a>
<FONT color="green">409</FONT>                    break;<a name="line.409"></a>
<FONT color="green">410</FONT>                case MLArray.mxCHAR_CLASS:<a name="line.410"></a>
<FONT color="green">411</FONT>                    MLChar mlchar = new MLChar(name, dims, type, attributes);<a name="line.411"></a>
<FONT color="green">412</FONT>                    <a name="line.412"></a>
<FONT color="green">413</FONT>                    //read real<a name="line.413"></a>
<FONT color="green">414</FONT>                    tag = new ISMatTag(buf);<a name="line.414"></a>
<FONT color="green">415</FONT>                    char[] ac = tag.readToCharArray();<a name="line.415"></a>
<FONT color="green">416</FONT>                    for ( int i = 0; i &lt; ac.length; i++ )<a name="line.416"></a>
<FONT color="green">417</FONT>                    {<a name="line.417"></a>
<FONT color="green">418</FONT>                        mlchar.setChar( ac[i], i );<a name="line.418"></a>
<FONT color="green">419</FONT>                    }<a name="line.419"></a>
<FONT color="green">420</FONT>                    mlArray = mlchar;<a name="line.420"></a>
<FONT color="green">421</FONT>                    break;<a name="line.421"></a>
<FONT color="green">422</FONT>                case MLArray.mxSPARSE_CLASS:<a name="line.422"></a>
<FONT color="green">423</FONT>                    MLSparse sparse = new MLSparse(name, dims, attributes, nzmax);<a name="line.423"></a>
<FONT color="green">424</FONT>                    <a name="line.424"></a>
<FONT color="green">425</FONT>                    //read ir (row indices)<a name="line.425"></a>
<FONT color="green">426</FONT>                    tag = new ISMatTag(buf);<a name="line.426"></a>
<FONT color="green">427</FONT>                    int[] ir = tag.readToIntArray();<a name="line.427"></a>
<FONT color="green">428</FONT>                    //read jc (column indices)<a name="line.428"></a>
<FONT color="green">429</FONT>                    tag = new ISMatTag(buf);<a name="line.429"></a>
<FONT color="green">430</FONT>                    int[] jc = tag.readToIntArray();<a name="line.430"></a>
<FONT color="green">431</FONT>                    <a name="line.431"></a>
<FONT color="green">432</FONT>                    //read pr (reall part)<a name="line.432"></a>
<FONT color="green">433</FONT>                    tag = new ISMatTag(buf);<a name="line.433"></a>
<FONT color="green">434</FONT>                    double[] ad1 = tag.readToDoubleArray();<a name="line.434"></a>
<FONT color="green">435</FONT>                    int n = 0;<a name="line.435"></a>
<FONT color="green">436</FONT>                    for ( int i = 0; i &lt; ir.length; i++)<a name="line.436"></a>
<FONT color="green">437</FONT>                    {<a name="line.437"></a>
<FONT color="green">438</FONT>                        if ( i &lt; sparse.getN() )<a name="line.438"></a>
<FONT color="green">439</FONT>                        {<a name="line.439"></a>
<FONT color="green">440</FONT>                            n = jc[i];<a name="line.440"></a>
<FONT color="green">441</FONT>                        }<a name="line.441"></a>
<FONT color="green">442</FONT>                        sparse.setReal(Double.valueOf(ad1[i]), ir[i], n);<a name="line.442"></a>
<FONT color="green">443</FONT>                    }<a name="line.443"></a>
<FONT color="green">444</FONT>                    <a name="line.444"></a>
<FONT color="green">445</FONT>                    //read pi (imaginary part)<a name="line.445"></a>
<FONT color="green">446</FONT>                    if ( sparse.isComplex() )<a name="line.446"></a>
<FONT color="green">447</FONT>                    {<a name="line.447"></a>
<FONT color="green">448</FONT>                        tag = new ISMatTag(buf);<a name="line.448"></a>
<FONT color="green">449</FONT>                        double[] ad2 = tag.readToDoubleArray();<a name="line.449"></a>
<FONT color="green">450</FONT>                        <a name="line.450"></a>
<FONT color="green">451</FONT>                        //TODO: check if I should throw MatlabIOException<a name="line.451"></a>
<FONT color="green">452</FONT>                        int n1 = 0;<a name="line.452"></a>
<FONT color="green">453</FONT>                        for ( int i = 0; i &lt; ir.length; i++)<a name="line.453"></a>
<FONT color="green">454</FONT>                        {<a name="line.454"></a>
<FONT color="green">455</FONT>                            if ( i &lt; sparse.getN() )<a name="line.455"></a>
<FONT color="green">456</FONT>                            {<a name="line.456"></a>
<FONT color="green">457</FONT>                                n1 = jc[i];<a name="line.457"></a>
<FONT color="green">458</FONT>                            }<a name="line.458"></a>
<FONT color="green">459</FONT>                            sparse.setImaginary(Double.valueOf(ad2[i]), ir[i], n1);<a name="line.459"></a>
<FONT color="green">460</FONT>                        }<a name="line.460"></a>
<FONT color="green">461</FONT>                    }<a name="line.461"></a>
<FONT color="green">462</FONT>                    mlArray = sparse;<a name="line.462"></a>
<FONT color="green">463</FONT>                    break;<a name="line.463"></a>
<FONT color="green">464</FONT>                default:<a name="line.464"></a>
<FONT color="green">465</FONT>                    throw new MatlabIOException("Incorrect matlab array class: " + MLArray.typeToString(type) );<a name="line.465"></a>
<FONT color="green">466</FONT>                   <a name="line.466"></a>
<FONT color="green">467</FONT>            }<a name="line.467"></a>
<FONT color="green">468</FONT>            return mlArray;<a name="line.468"></a>
<FONT color="green">469</FONT>        }<a name="line.469"></a>
<FONT color="green">470</FONT>        /**<a name="line.470"></a>
<FONT color="green">471</FONT>         * Converts byte array to &lt;code&gt;String&lt;/code&gt;. <a name="line.471"></a>
<FONT color="green">472</FONT>         * <a name="line.472"></a>
<FONT color="green">473</FONT>         * It assumes that String ends with \0 value.<a name="line.473"></a>
<FONT color="green">474</FONT>         * <a name="line.474"></a>
<FONT color="green">475</FONT>         * @param bytes byte array containing the string.<a name="line.475"></a>
<FONT color="green">476</FONT>         * @return String retrived from byte array.<a name="line.476"></a>
<FONT color="green">477</FONT>         * @throws IOException if reading error occured.<a name="line.477"></a>
<FONT color="green">478</FONT>         */<a name="line.478"></a>
<FONT color="green">479</FONT>        private String zeroEndByteArrayToString(byte[] bytes) throws IOException<a name="line.479"></a>
<FONT color="green">480</FONT>        {<a name="line.480"></a>
<FONT color="green">481</FONT>            ByteArrayOutputStream baos = new ByteArrayOutputStream();<a name="line.481"></a>
<FONT color="green">482</FONT>            DataOutputStream dos = new DataOutputStream( baos );<a name="line.482"></a>
<FONT color="green">483</FONT>            <a name="line.483"></a>
<FONT color="green">484</FONT>            for ( int i = 0; i &lt; bytes.length &amp;&amp; bytes[i] != 0; i++ )<a name="line.484"></a>
<FONT color="green">485</FONT>            {<a name="line.485"></a>
<FONT color="green">486</FONT>                dos.writeByte(bytes[i]);<a name="line.486"></a>
<FONT color="green">487</FONT>            }<a name="line.487"></a>
<FONT color="green">488</FONT>            return baos.toString();<a name="line.488"></a>
<FONT color="green">489</FONT>            <a name="line.489"></a>
<FONT color="green">490</FONT>        }<a name="line.490"></a>
<FONT color="green">491</FONT>        /**<a name="line.491"></a>
<FONT color="green">492</FONT>         * Reads Matrix flags.<a name="line.492"></a>
<FONT color="green">493</FONT>         * <a name="line.493"></a>
<FONT color="green">494</FONT>         * Modifies &lt;code&gt;buf&lt;/code&gt; position.<a name="line.494"></a>
<FONT color="green">495</FONT>         * <a name="line.495"></a>
<FONT color="green">496</FONT>         * @param buf &lt;code&gt;ByteBuffer&lt;/code&gt;<a name="line.496"></a>
<FONT color="green">497</FONT>         * @return flags int array<a name="line.497"></a>
<FONT color="green">498</FONT>         * @throws IOException if reading from buffer fails<a name="line.498"></a>
<FONT color="green">499</FONT>         */<a name="line.499"></a>
<FONT color="green">500</FONT>        private int[] readFlags(ByteBuffer buf) throws IOException<a name="line.500"></a>
<FONT color="green">501</FONT>        {<a name="line.501"></a>
<FONT color="green">502</FONT>            ISMatTag tag = new ISMatTag(buf);<a name="line.502"></a>
<FONT color="green">503</FONT>            <a name="line.503"></a>
<FONT color="green">504</FONT>            int[] flags = tag.readToIntArray();<a name="line.504"></a>
<FONT color="green">505</FONT>            <a name="line.505"></a>
<FONT color="green">506</FONT>            return flags;<a name="line.506"></a>
<FONT color="green">507</FONT>        }<a name="line.507"></a>
<FONT color="green">508</FONT>        /**<a name="line.508"></a>
<FONT color="green">509</FONT>         * Reads Matrix dimensions.<a name="line.509"></a>
<FONT color="green">510</FONT>         * <a name="line.510"></a>
<FONT color="green">511</FONT>         * Modifies &lt;code&gt;buf&lt;/code&gt; position.<a name="line.511"></a>
<FONT color="green">512</FONT>         * <a name="line.512"></a>
<FONT color="green">513</FONT>         * @param buf &lt;code&gt;ByteBuffer&lt;/code&gt;<a name="line.513"></a>
<FONT color="green">514</FONT>         * @return dimensions int array<a name="line.514"></a>
<FONT color="green">515</FONT>         * @throws IOException if reading from buffer fails<a name="line.515"></a>
<FONT color="green">516</FONT>         */<a name="line.516"></a>
<FONT color="green">517</FONT>        private int[] readDimension(ByteBuffer buf ) throws IOException<a name="line.517"></a>
<FONT color="green">518</FONT>        {<a name="line.518"></a>
<FONT color="green">519</FONT>            <a name="line.519"></a>
<FONT color="green">520</FONT>            ISMatTag tag = new ISMatTag(buf);<a name="line.520"></a>
<FONT color="green">521</FONT>            int[] dims = tag.readToIntArray();<a name="line.521"></a>
<FONT color="green">522</FONT>            return dims;<a name="line.522"></a>
<FONT color="green">523</FONT>            <a name="line.523"></a>
<FONT color="green">524</FONT>        }<a name="line.524"></a>
<FONT color="green">525</FONT>        /**<a name="line.525"></a>
<FONT color="green">526</FONT>         * Reads Matrix name.<a name="line.526"></a>
<FONT color="green">527</FONT>         * <a name="line.527"></a>
<FONT color="green">528</FONT>         * Modifies &lt;code&gt;buf&lt;/code&gt; position.<a name="line.528"></a>
<FONT color="green">529</FONT>         * <a name="line.529"></a>
<FONT color="green">530</FONT>         * @param buf &lt;code&gt;ByteBuffer&lt;/code&gt;<a name="line.530"></a>
<FONT color="green">531</FONT>         * @return name &lt;code&gt;String&lt;/code&gt;<a name="line.531"></a>
<FONT color="green">532</FONT>         * @throws IOException if reading from buffer fails<a name="line.532"></a>
<FONT color="green">533</FONT>         */<a name="line.533"></a>
<FONT color="green">534</FONT>        private String readName(ByteBuffer buf) throws IOException<a name="line.534"></a>
<FONT color="green">535</FONT>        {<a name="line.535"></a>
<FONT color="green">536</FONT>            String s;<a name="line.536"></a>
<FONT color="green">537</FONT>            <a name="line.537"></a>
<FONT color="green">538</FONT>            ISMatTag tag = new ISMatTag(buf);<a name="line.538"></a>
<FONT color="green">539</FONT>            char[] ac = tag.readToCharArray();<a name="line.539"></a>
<FONT color="green">540</FONT>            s = new String(ac);<a name="line.540"></a>
<FONT color="green">541</FONT>    <a name="line.541"></a>
<FONT color="green">542</FONT>            return s;<a name="line.542"></a>
<FONT color="green">543</FONT>        }<a name="line.543"></a>
<FONT color="green">544</FONT>        /**<a name="line.544"></a>
<FONT color="green">545</FONT>         * Reads MAT-file header.<a name="line.545"></a>
<FONT color="green">546</FONT>         * <a name="line.546"></a>
<FONT color="green">547</FONT>         * Modifies &lt;code&gt;buf&lt;/code&gt; position.<a name="line.547"></a>
<FONT color="green">548</FONT>         * <a name="line.548"></a>
<FONT color="green">549</FONT>         * @param buf<a name="line.549"></a>
<FONT color="green">550</FONT>         *            &lt;code&gt;ByteBuffer&lt;/code&gt;<a name="line.550"></a>
<FONT color="green">551</FONT>         * @throws IOException<a name="line.551"></a>
<FONT color="green">552</FONT>         *             if reading from buffer fails or if this is not a valid<a name="line.552"></a>
<FONT color="green">553</FONT>         *             MAT-file<a name="line.553"></a>
<FONT color="green">554</FONT>         */<a name="line.554"></a>
<FONT color="green">555</FONT>        private void readHeader(ByteBuffer buf) throws IOException<a name="line.555"></a>
<FONT color="green">556</FONT>        {<a name="line.556"></a>
<FONT color="green">557</FONT>            //header values<a name="line.557"></a>
<FONT color="green">558</FONT>            String description;<a name="line.558"></a>
<FONT color="green">559</FONT>            int version;<a name="line.559"></a>
<FONT color="green">560</FONT>            byte[] endianIndicator = new byte[2];<a name="line.560"></a>
<FONT color="green">561</FONT>            <a name="line.561"></a>
<FONT color="green">562</FONT>            //desctiptive text 116 bytes<a name="line.562"></a>
<FONT color="green">563</FONT>            byte[] descriptionBuffer = new byte[116];<a name="line.563"></a>
<FONT color="green">564</FONT>            buf.get(descriptionBuffer);<a name="line.564"></a>
<FONT color="green">565</FONT>            <a name="line.565"></a>
<FONT color="green">566</FONT>            description = zeroEndByteArrayToString(descriptionBuffer);<a name="line.566"></a>
<FONT color="green">567</FONT>            <a name="line.567"></a>
<FONT color="green">568</FONT>            if ( !description.matches("MATLAB 5.0 MAT-file.*") )<a name="line.568"></a>
<FONT color="green">569</FONT>            {<a name="line.569"></a>
<FONT color="green">570</FONT>                throw new MatlabIOException("This is not a valid MATLAB 5.0 MAT-file.");<a name="line.570"></a>
<FONT color="green">571</FONT>            }<a name="line.571"></a>
<FONT color="green">572</FONT>            <a name="line.572"></a>
<FONT color="green">573</FONT>            //subsyst data offset 8 bytes<a name="line.573"></a>
<FONT color="green">574</FONT>            buf.position( buf.position() + 8);<a name="line.574"></a>
<FONT color="green">575</FONT>            <a name="line.575"></a>
<FONT color="green">576</FONT>            byte[] bversion = new byte[2];<a name="line.576"></a>
<FONT color="green">577</FONT>            //vesion 2 bytes<a name="line.577"></a>
<FONT color="green">578</FONT>            buf.get(bversion);<a name="line.578"></a>
<FONT color="green">579</FONT>            <a name="line.579"></a>
<FONT color="green">580</FONT>            //endian indicator 2 bytes<a name="line.580"></a>
<FONT color="green">581</FONT>            buf.get(endianIndicator);<a name="line.581"></a>
<FONT color="green">582</FONT>            <a name="line.582"></a>
<FONT color="green">583</FONT>            //program reading the MAT-file must perform byte swapping to interpret the data<a name="line.583"></a>
<FONT color="green">584</FONT>            //in the MAT-file correctly<a name="line.584"></a>
<FONT color="green">585</FONT>            if ( (char)endianIndicator[0] == 'I' &amp;&amp; (char)endianIndicator[1] == 'M')<a name="line.585"></a>
<FONT color="green">586</FONT>            {<a name="line.586"></a>
<FONT color="green">587</FONT>                byteOrder = ByteOrder.LITTLE_ENDIAN;<a name="line.587"></a>
<FONT color="green">588</FONT>                version = bversion[1] &amp; 0xff | bversion[0] &lt;&lt; 8;<a name="line.588"></a>
<FONT color="green">589</FONT>            }<a name="line.589"></a>
<FONT color="green">590</FONT>            else<a name="line.590"></a>
<FONT color="green">591</FONT>            {<a name="line.591"></a>
<FONT color="green">592</FONT>                byteOrder = ByteOrder.BIG_ENDIAN;<a name="line.592"></a>
<FONT color="green">593</FONT>                version = bversion[0] &amp; 0xff | bversion[1] &lt;&lt; 8;<a name="line.593"></a>
<FONT color="green">594</FONT>            }<a name="line.594"></a>
<FONT color="green">595</FONT>            <a name="line.595"></a>
<FONT color="green">596</FONT>            buf.order( byteOrder );<a name="line.596"></a>
<FONT color="green">597</FONT>            <a name="line.597"></a>
<FONT color="green">598</FONT>            matFileHeader = new MatFileHeader(description, version, endianIndicator);<a name="line.598"></a>
<FONT color="green">599</FONT>        }<a name="line.599"></a>
<FONT color="green">600</FONT>        /**<a name="line.600"></a>
<FONT color="green">601</FONT>         * TAG operator. Facilitates reading operations.<a name="line.601"></a>
<FONT color="green">602</FONT>         * <a name="line.602"></a>
<FONT color="green">603</FONT>         * &lt;i&gt;Note: reading from buffer modifies it's position&lt;/i&gt;<a name="line.603"></a>
<FONT color="green">604</FONT>         * <a name="line.604"></a>
<FONT color="green">605</FONT>         * @author Wojciech Gradkowski (&lt;a href="mailto:wgradkowski@gmail.com"&gt;wgradkowski@gmail.com&lt;/a&gt;)<a name="line.605"></a>
<FONT color="green">606</FONT>         */<a name="line.606"></a>
<FONT color="green">607</FONT>        private class ISMatTag extends MatTag<a name="line.607"></a>
<FONT color="green">608</FONT>        {<a name="line.608"></a>
<FONT color="green">609</FONT>            public ByteBuffer buf;<a name="line.609"></a>
<FONT color="green">610</FONT>            private int padding;<a name="line.610"></a>
<FONT color="green">611</FONT>            <a name="line.611"></a>
<FONT color="green">612</FONT>            public ISMatTag(ByteBuffer buf) throws IOException<a name="line.612"></a>
<FONT color="green">613</FONT>            {<a name="line.613"></a>
<FONT color="green">614</FONT>                //must call parent constructor<a name="line.614"></a>
<FONT color="green">615</FONT>                super(0,0);<a name="line.615"></a>
<FONT color="green">616</FONT>                this.buf = buf;<a name="line.616"></a>
<FONT color="green">617</FONT>                int tmp = buf.getInt();<a name="line.617"></a>
<FONT color="green">618</FONT>                <a name="line.618"></a>
<FONT color="green">619</FONT>                boolean compressed;<a name="line.619"></a>
<FONT color="green">620</FONT>                //data not packed in the tag<a name="line.620"></a>
<FONT color="green">621</FONT>                if ( tmp &gt;&gt; 16 == 0 )<a name="line.621"></a>
<FONT color="green">622</FONT>                {    <a name="line.622"></a>
<FONT color="green">623</FONT>                    type = tmp;<a name="line.623"></a>
<FONT color="green">624</FONT>                    size = buf.getInt();<a name="line.624"></a>
<FONT color="green">625</FONT>                    compressed = false;<a name="line.625"></a>
<FONT color="green">626</FONT>                }<a name="line.626"></a>
<FONT color="green">627</FONT>                else //data _packed_ in the tag (compressed)<a name="line.627"></a>
<FONT color="green">628</FONT>                {<a name="line.628"></a>
<FONT color="green">629</FONT>                    size = tmp &gt;&gt; 16; // 2 more significant bytes<a name="line.629"></a>
<FONT color="green">630</FONT>                    type = tmp &amp; 0xffff; // 2 less significant bytes;<a name="line.630"></a>
<FONT color="green">631</FONT>                    compressed = true;<a name="line.631"></a>
<FONT color="green">632</FONT>                }<a name="line.632"></a>
<FONT color="green">633</FONT>                padding = getPadding(size, compressed);<a name="line.633"></a>
<FONT color="green">634</FONT>            }<a name="line.634"></a>
<FONT color="green">635</FONT>            public double[] readToDoubleArray() throws IOException<a name="line.635"></a>
<FONT color="green">636</FONT>            {<a name="line.636"></a>
<FONT color="green">637</FONT>                //allocate memory for array elements<a name="line.637"></a>
<FONT color="green">638</FONT>                int elements = size/sizeOf();<a name="line.638"></a>
<FONT color="green">639</FONT>                double[] ad = new double[elements];<a name="line.639"></a>
<FONT color="green">640</FONT>                <a name="line.640"></a>
<FONT color="green">641</FONT>                MatFileInputStream mfis = new MatFileInputStream( buf, type );<a name="line.641"></a>
<FONT color="green">642</FONT>    <a name="line.642"></a>
<FONT color="green">643</FONT>                for ( int i = 0; i &lt; elements; i++ )<a name="line.643"></a>
<FONT color="green">644</FONT>                {<a name="line.644"></a>
<FONT color="green">645</FONT>                    ad[i] = mfis.readDouble();<a name="line.645"></a>
<FONT color="green">646</FONT>                }<a name="line.646"></a>
<FONT color="green">647</FONT>                <a name="line.647"></a>
<FONT color="green">648</FONT>                //skip padding<a name="line.648"></a>
<FONT color="green">649</FONT>                if ( padding &gt; 0 )<a name="line.649"></a>
<FONT color="green">650</FONT>                {<a name="line.650"></a>
<FONT color="green">651</FONT>                    buf.position( buf.position() + padding );<a name="line.651"></a>
<FONT color="green">652</FONT>                }<a name="line.652"></a>
<FONT color="green">653</FONT>                return ad;<a name="line.653"></a>
<FONT color="green">654</FONT>            }<a name="line.654"></a>
<FONT color="green">655</FONT>            public int[] readToIntArray() throws IOException<a name="line.655"></a>
<FONT color="green">656</FONT>            {<a name="line.656"></a>
<FONT color="green">657</FONT>                //allocate memory for array elements<a name="line.657"></a>
<FONT color="green">658</FONT>                int elements = size/sizeOf();<a name="line.658"></a>
<FONT color="green">659</FONT>                int[] ai = new int[elements];<a name="line.659"></a>
<FONT color="green">660</FONT>                <a name="line.660"></a>
<FONT color="green">661</FONT>                MatFileInputStream mfis = new MatFileInputStream( buf, type );<a name="line.661"></a>
<FONT color="green">662</FONT>    <a name="line.662"></a>
<FONT color="green">663</FONT>                for ( int i = 0; i &lt; elements; i++ )<a name="line.663"></a>
<FONT color="green">664</FONT>                {<a name="line.664"></a>
<FONT color="green">665</FONT>                    ai[i] = mfis.readInt();<a name="line.665"></a>
<FONT color="green">666</FONT>                }<a name="line.666"></a>
<FONT color="green">667</FONT>                <a name="line.667"></a>
<FONT color="green">668</FONT>                //skip padding<a name="line.668"></a>
<FONT color="green">669</FONT>                if ( padding &gt; 0 )<a name="line.669"></a>
<FONT color="green">670</FONT>                {<a name="line.670"></a>
<FONT color="green">671</FONT>                    buf.position( buf.position() + padding );<a name="line.671"></a>
<FONT color="green">672</FONT>                }<a name="line.672"></a>
<FONT color="green">673</FONT>                return ai;<a name="line.673"></a>
<FONT color="green">674</FONT>            }<a name="line.674"></a>
<FONT color="green">675</FONT>            public char[] readToCharArray() throws IOException<a name="line.675"></a>
<FONT color="green">676</FONT>            {<a name="line.676"></a>
<FONT color="green">677</FONT>                //allocate memory for array elements<a name="line.677"></a>
<FONT color="green">678</FONT>                int elements = size/sizeOf();<a name="line.678"></a>
<FONT color="green">679</FONT>                char[] ac = new char[elements];<a name="line.679"></a>
<FONT color="green">680</FONT>                <a name="line.680"></a>
<FONT color="green">681</FONT>                MatFileInputStream mfis = new MatFileInputStream( buf, type );<a name="line.681"></a>
<FONT color="green">682</FONT>    <a name="line.682"></a>
<FONT color="green">683</FONT>                for ( int i = 0; i &lt; elements; i++ )<a name="line.683"></a>
<FONT color="green">684</FONT>                {<a name="line.684"></a>
<FONT color="green">685</FONT>                    ac[i] = mfis.readChar();<a name="line.685"></a>
<FONT color="green">686</FONT>                }<a name="line.686"></a>
<FONT color="green">687</FONT>                <a name="line.687"></a>
<FONT color="green">688</FONT>                //skip padding<a name="line.688"></a>
<FONT color="green">689</FONT>                if ( padding &gt; 0 )<a name="line.689"></a>
<FONT color="green">690</FONT>                {<a name="line.690"></a>
<FONT color="green">691</FONT>                    buf.position( buf.position() + padding );<a name="line.691"></a>
<FONT color="green">692</FONT>                }<a name="line.692"></a>
<FONT color="green">693</FONT>                return ac;<a name="line.693"></a>
<FONT color="green">694</FONT>            }<a name="line.694"></a>
<FONT color="green">695</FONT>        }<a name="line.695"></a>
<FONT color="green">696</FONT>    }<a name="line.696"></a>




























































</PRE>
</BODY>
</HTML>
